import { ViewPlugin } from '@codemirror/next/view';
import { addEvents } from "../../../helpers/add-events.js";
import { defineEffectField } from "../../../helpers/define-effect-field.js";
const [isConnected, dispatchIsConnectedChanged] = defineEffectField(false);
export { isConnected };
export const connectionState = connection => {
  return [isConnected, ViewPlugin.define(view => {
    const removeEvents = addEvents(connection, {
      open: () => dispatchIsConnectedChanged(view, true),
      error: () => dispatchIsConnectedChanged(view, false),
      close: () => dispatchIsConnectedChanged(view, false)
    });
    return {
      destroy: () => removeEvents()
    };
  })];
};